<template>
  <div>
    <input type="file" class="hidden" @change="uploadPhoto" ref="file">
    <h1 class="mb-8">Would you like to add another photo?</h1>
    <div class="grid grid-cols-3 gap-3 mb-8">
      <div
        class="photo bg-defaults"
        :style="`background-image: url(${firstPhoto})`"
      >
      </div>
      <div
        class="photo bg-defaults"
        v-for="img in additionalImages"
        :key="img.id"
        :style="`background-image: url(${img.src})`"
      >
      </div>
      <div class="relative photo cursor-pointer border border-grey border border-dashed flex flex-col items-center">
        <div
          @click="$refs.file.click()"
          class="flex flex-col items-center justify-center absolute top-1/2 left-1/2 transform -translate-x-1/2 -translate-y-1/2"
        >
          <div class="whitespace-nowrap mb-2 text-sm sm:text-base font-bold text-green-black">Add Photo</div>
          <div class="sm:w-12 sm:h-12 w-8 color-green-black text-4xl h-8 rounded-full bg-green-lightest flex items-center justify-center">
            +
          </div>
        </div>
      </div>
    </div>
    <common-btn
      text="Continue"
      class="mb-5"
      @click="$emit('nextStage')"
    />
    <PhotoWarning/>
    <TakePhotoOptionsModal
      v-if="isOptionsShown"
      @upload="$refs.file.click()"
      @close="isOptionsShown = false"
    />
  </div>
</template>

<script>
import TakePhotoOptionsModal from "@/components/modals/TakePhotoOptionsModal";
import {answersMixin} from "@/utils/mixins";
import PhotoWarning from "@/components/misc/PhotoWarning";
export default {
  mixins: [answersMixin],
  name: "SkinAnalysis3",
  components: {PhotoWarning, TakePhotoOptionsModal},
  watch: {
    additionalImages: {
      handler(newVal) {
        this.setAnswer(this.answersKeys.SKIN_ANALYSIS, newVal, 'stage_3')
      },
      deep: true,
    }
  },
  data() {
    return {
      isOptionsShown: false,
      additionalImages: [],
      defaultImg: require('@/assets/img/misc/placeholder-image.png')
    }
  },
  methods: {
    uploadPhoto(event) {
      const imageFile = event.target.files[0]

      const reader = new FileReader()

      reader.onload = e => {
        this.additionalImages.push({
          id: Date.now(),
          src: e.target.result
        })
        this.$refs.file.value = ''
      }

      reader.readAsDataURL(imageFile)
    }
  },
  computed: {
    firstPhoto() {
      return this.answer(this.answersKeys.SKIN_ANALYSIS)?.stage_2_photo ?? this.defaultImg
    }
  }
}
</script>

<style scoped>
.photo {
  @apply rounded-lg;
  padding-bottom: 100%;
}
</style>
